'use strict';

const async = require('async');
const vk = new (require('vk-io'));
vk.setting({
	app: 5562610,
	phone: '', // Номер телефона вида 749531116869
	pass: '' // Пароль
});

const auth = vk.standloneAuth();

auth.run()
.then((token) => {
	console.log('Token:',token);

	vk.setToken(token);

	return true;
})
.then(() => {
	return vk.stream.fave.getPhotos();
})
.then((likes) => {
	console.log('Кол-во лайкнутых фотографий:',likes.length);

	return removeLike('photo',likes);
})
.then(() => {
	return vk.stream.fave.getPosts({
		extended: 0
	});
})
.then((likes) => {
	console.log('Кол-во лайкнутых постов:',likes.length);

	return removeLike('post',likes);
})
.then(() => {
	return vk.stream.fave.getVideos({
		extended: 0
	});
})
.then((likes) => {
	console.log('Кол-во лайкнутых видео:',likes.length);

	return removeLike('video',likes);
})
.then(() => {
	return vk.stream.audio.get({
		need_user: 0
	});
})
.then((audios) => {
	console.log('Кол-во ваших аудиозаписей:',audios.length);

	return eachList(audios,(audio,next) => {
		vk.api.audio.delete({
			audio_id: audio.id,
			owner_id: audio.owner_id
		})
		.then(() => {
			console.log('Аудиозапись'+audio.owner_id+'_'+audio.id,'удалена!');

			next();
		})
		.catch(() => {
			console.log('Не удалось удалить аудиозапись',type,audio.owner_id,audio.id);

			next();
		});
	});
})
.then(() => {
	return vk.stream.video.get({
		extended: 0
	});
})
.then((videos) => {
	console.log('Кол-во ваших видеозаписей:',videos.length);

	return eachList(videos,(video,next) => {
		vk.api.video.delete({
			video_id: video.id,
			owner_id: video.owner_id
		})
		.then(() => {
			console.log('Видеозапись'+video.owner_id+'_'+video.id,'удалена!');

			next();
		})
		.catch(() => {
			console.log('Не удалось удалить видеозапись',type,video.owner_id,video.id);

			next();
		});
	});
})
.then(() => {
	return vk.stream.docs.get();
})
.then((docs) => {
	console.log('Кол-во ваших документов:',docs.length);

	return eachList(docs,(doc,next) => {
		vk.api.video.delete({
			video_id: doc.id,
			owner_id: doc.owner_id
		})
		.then(() => {
			console.log('Документ'+doc.owner_id+'_'+doc.id,'удалена!');

			next();
		})
		.catch(() => {
			console.log('Не удалось удалить видеозапись',type,doc.owner_id,doc.id);

			next();
		});
	});
})
.then(() => {
	return vk.stream.groups.get({
		extended: 0
	});
})
.then((groups) => {
	return eachList(groups,(group,next) => {
		vk.api.groups.leave({
			group_id: group
		})
		.then(() => {
			console.log('Была покинута группа club'+group);

			next();
		})
		.catch(() => {
			console.log('Не удалось покинуть группу club'+group);

			next();
		});
	});
})
.then(() => {
	return vk.stream.friends.getRequests({
		out: 1
	});
})
.then((subscribes) => {
	console.log('Кол-во подписок на пользователей:',subscribes.length);

	return eachList(subscribes,(user,next) => {
		vk.api.friends.delete({
			user_id: user
		})
		.then(() => {
			console.log('Отписались от id'+user);

			next();
		})
		.catch(() => {
			console.log('Не удалось отписаться id'+user);

			next();
		});
	});
})
.then(() => {
	return vk.stream.wall.get({
		extended: 0
	});
})
.then((posts) => {
	console.log('Кол-во постов пользователя:',posts.length);

	return eachList(posts,(post,next) => {
		vk.api.wall.delete({
			id: post.id,
			owner_id: post.owner_id
		})
		.then(() => {
			console.log('Удалили запись post'+post.owner_id+'_'+post.id);

			next();
		})
		.catch(() => {
			console.log('Не удалось удалить запись post'+post.owner_id+'_'+post.id);

			next();
		});
	});
})
.then(() => {
	console.log('Чистка завершена!');
})
.catch((error) => {
	console.log('Произошла серьезная ошибка!',error);
});


/**
 * Удаляет лайк по типу
 *
 * @param string type
 * @param array  list
 *
 * @return promise
 */
function removeLike (type,list) {
	return eachList(list,(like,next) => {
		vk.api.likes.delete({
			type: type,
			item_id: like.id,
			owner_id: like.owner_id
		})
		.then(() => {
			console.log('Лайк',type+like.owner_id+'_'+like.id,'удалён!');

			next();
		})
		.catch(() => {
			console.log('Не удалось удалить лайк!',type+like.owner_id+'_'+like.id);

			next();
		});
	});
}

/**
 * Удаляет объект
 *
 * @param array  list
 *
 * @return promise
 */
function eachList (list,callback) {
	return new Promise((resolve) => {
		async.each(
			list,
			callback,
			(error) => {
				if (!error) {
					resolve();
				}
			}
		)
	});
}
